pcl::RadiusOutlierRemoval< PointT > Class Template Reference
Module filters

RadiusOutlierRemoval filters points in a cloud based on the number of neighbors they have. More...

`#include <pcl/filters/radius_outlier_removal.h>`

Inheritance diagram for pcl::RadiusOutlierRemoval< PointT >:

## Public Types

typedef boost::shared_ptr< RadiusOutlierRemoval< PointT > > | Ptr
typedef boost::shared_ptr< const RadiusOutlierRemoval< PointT > > | ConstPtr
Public Types inherited from pcl::FilterIndices< PointT >
typedef pcl::PointCloud< PointT > | PointCloud
typedef boost::shared_ptr< FilterIndices< PointT > > | Ptr
typedef boost::shared_ptr< const FilterIndices< PointT > > | ConstPtr
Public Types inherited from pcl::Filter< PointT >
typedef boost::shared_ptr< Filter< PointT > > | Ptr
typedef boost::shared_ptr< const Filter< PointT > > | ConstPtr
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
Public Types inherited from pcl::PCLBase< PointT >
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| RadiusOutlierRemoval (bool extract_removed_indices=false)
| Constructor. More...
void | setRadiusSearch (double radius)
| Set the radius of the sphere that will determine which points are neighbors. More...
double | getRadiusSearch ()
| Get the radius of the sphere that will determine which points are neighbors. More...
void | setMinNeighborsInRadius (int min_pts)
| Set the number of neighbors that need to be present in order to be classified as an inlier. More...
int | getMinNeighborsInRadius ()
| Get the number of neighbors that need to be present in order to be classified as an inlier. More...
Public Member Functions inherited from pcl::FilterIndices< PointT >
| FilterIndices (bool extract_removed_indices=false)
| Constructor. More...
virtual | ~FilterIndices ()
| Empty virtual destructor. More...
void | filter (PointCloud &output)
void | filter (std::vector< int > &indices)
| Calls the filtering method and returns the filtered point cloud indices. More...
void | setNegative (bool negative)
| Set whether the regular conditions for points filtering should apply, or the inverted conditions. More...
bool | getNegative ()
| Get whether the regular conditions for points filtering should apply, or the inverted conditions. More...
void | setKeepOrganized (bool keep_organized)
| Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
bool | getKeepOrganized ()
| Get whether the filtered points should be kept and set to the value given through setUserFilterValue (default = NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
void | setUserFilterValue (float value)
| Provide a value that the filtered points should be set to instead of removing them. More...
Public Member Functions inherited from pcl::Filter< PointT >
| Filter (bool extract_removed_indices=false)
| Empty constructor. More...
virtual | ~Filter ()
| Empty destructor. More...
IndicesConstPtr const | getRemovedIndices ()
| Get the point indices being removed. More...
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed. More...
void | filter (PointCloud &output)
| Calls the filtering method and returns the filtered dataset in output. More...
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Types

typedef FilterIndices< PointT >::PointCloud | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef pcl::search::Search< PointT >::Ptr | SearcherPtr

## Protected Member Functions

void | applyFilter (PointCloud &output)
| Filtered results are stored in a separate point cloud. More...
void | applyFilter (std::vector< int > &indices)
| Filtered results are indexed by an indices array. More...
void | applyFilterIndices (std::vector< int > &indices)
| Filtered results are indexed by an indices array. More...
Protected Member Functions inherited from pcl::Filter< PointT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Additional Inherited Members

Protected Attributes inherited from pcl::FilterIndices< PointT >
bool | negative_
| False = normal filter behavior (default), true = inverted behavior. More...
bool | keep_organized_
| False = remove points (default), true = redefine points, keep structure. More...
float | user_filter_value_
| The user given value that the filtered point dimensions should be set to (default = NaN). More...
Protected Attributes inherited from pcl::Filter< PointT >
IndicesPtr | removed_indices_
| Indices of the points that are removed. More...
std::string | filter_name_
| The filter name. More...
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points. More...
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointT>
class pcl::RadiusOutlierRemoval< PointT >

RadiusOutlierRemoval filters points in a cloud based on the number of neighbors they have.

Iterates through the entire input once, and for each point, retrieves the number of neighbors within a certain radius. The point will be considered an outlier if it has too few neighbors, as determined by setMinNeighborsInRadius(). The radius can be changed using setRadiusSearch().
The neighbors found for each query point will be found amongst ALL points of setInputCloud(), not just those indexed by setIndices(). The setIndices() method only indexes the points that will be iterated through as search query points.
Usage example:

pcl::RadiusOutlierRemoval<PointType> rorfilter (true); // Initializing with true will allow us to extract the removed indices
rorfilter.setInputCloud (cloud_in);
rorfilter.setRadiusSearch (0.1);
rorfilter.setMinNeighborsInRadius (5);
rorfilter.setNegative (true);
rorfilter.filter (*cloud_out);
// The resulting cloud_out contains all points of cloud_in that have 4 or less neighbors within the 0.1 search radius
indices_rem = rorfilter.getRemovedIndices ();
// The indices_rem array indexes all points of cloud_in that have 5 or more neighbors within the 0.1 search radius

Author
  Radu Bogdan Rusu

Definition at line 72 of file radius_outlier_removal.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointT>

typedef boost::shared_ptr< const RadiusOutlierRemoval<PointT> > pcl::RadiusOutlierRemoval< PointT >::ConstPtr

Definition at line 83 of file radius_outlier_removal.h.

## PointCloud

template<typename PointT>

typedef FilterIndices<PointT>::PointCloud pcl::RadiusOutlierRemoval< PointT >::PointCloud

protected

Definition at line 75 of file radius_outlier_removal.h.

## PointCloudConstPtr

template<typename PointT>

typedef PointCloud::ConstPtr pcl::RadiusOutlierRemoval< PointT >::PointCloudConstPtr

protected

Definition at line 77 of file radius_outlier_removal.h.

## PointCloudPtr

template<typename PointT>

typedef PointCloud::Ptr pcl::RadiusOutlierRemoval< PointT >::PointCloudPtr

protected

Definition at line 76 of file radius_outlier_removal.h.

## Ptr

template<typename PointT>

typedef boost::shared_ptr< RadiusOutlierRemoval<PointT> > pcl::RadiusOutlierRemoval< PointT >::Ptr

Definition at line 82 of file radius_outlier_removal.h.

## SearcherPtr

template<typename PointT>

typedef pcl::search::Search<PointT>::Ptr pcl::RadiusOutlierRemoval< PointT >::SearcherPtr

protected

Definition at line 78 of file radius_outlier_removal.h.

## Constructor & Destructor Documentation

## RadiusOutlierRemoval()

template<typename PointT>

pcl::RadiusOutlierRemoval< PointT >::RadiusOutlierRemoval | ( | bool | extract_removed_indices = `false` | ) |

inline

Constructor.

Parameters

  [in] | extract_removed_indices | Set to true if you want to be able to extract the indices of points being removed (default = false).

Definition at line 89 of file radius_outlier_removal.h.

References pcl::Filter< PointT >::filter_name_.

## Member Function Documentation

## applyFilter() [1/2]

template<typename PointT >

void pcl::RadiusOutlierRemoval< PointT >::applyFilter | ( | PointCloud & | output | ) |

protected virtual

Filtered results are stored in a separate point cloud.

Parameters

  [out] | output | The resultant point cloud.

Implements pcl::FilterIndices< PointT >.

Definition at line 48 of file radius_outlier_removal.hpp.

References pcl::copyPointCloud(), pcl::PointCloud< PointT >::is_dense, and pcl::PointCloud< PointT >::points.

Referenced by pcl::RadiusOutlierRemoval< PointT >::getMinNeighborsInRadius().

## applyFilter() [2/2]

template<typename PointT>

void pcl::RadiusOutlierRemoval< PointT >::applyFilter | ( | std::vector< int > & | indices | ) |

inline protected virtual

Filtered results are indexed by an indices array.

Parameters

  [out] | indices | The resultant indices.

Implements pcl::FilterIndices< PointT >.

Definition at line 163 of file radius_outlier_removal.h.

References pcl::RadiusOutlierRemoval< PointT >::applyFilterIndices().

## applyFilterIndices()

template<typename PointT >

void pcl::RadiusOutlierRemoval< PointT >::applyFilterIndices | ( | std::vector< int > & | indices | ) |

protected

Filtered results are indexed by an indices array.

Parameters

  [out] | indices | The resultant indices.

Definition at line 73 of file radius_outlier_removal.hpp.

Referenced by pcl::RadiusOutlierRemoval< PointT >::applyFilter().

## getMinNeighborsInRadius()

template<typename PointT>

int pcl::RadiusOutlierRemoval< PointT >::getMinNeighborsInRadius | ( |  | ) |

inline

Get the number of neighbors that need to be present in order to be classified as an inlier.

The number of points within setRadiusSearch() from the query point will need to be equal or greater than this number in order to be classified as an inlier point (i.e. will not be filtered).

Returns
  The minimum number of neighbors (default = 1).

Definition at line 137 of file radius_outlier_removal.h.

References pcl::RadiusOutlierRemoval< PointT >::applyFilter().

## getRadiusSearch()

template<typename PointT>

double pcl::RadiusOutlierRemoval< PointT >::getRadiusSearch | ( |  | ) |

inline

Get the radius of the sphere that will determine which points are neighbors.

The number of points within this distance from the query point will need to be equal or greater than setMinNeighborsInRadius() in order to be classified as an inlier point (i.e. will not be filtered).

Returns
  The radius of the sphere for nearest neighbor searching.

Definition at line 115 of file radius_outlier_removal.h.

## setMinNeighborsInRadius()

template<typename PointT>

void pcl::RadiusOutlierRemoval< PointT >::setMinNeighborsInRadius | ( | int | min_pts | ) |

inline

Set the number of neighbors that need to be present in order to be classified as an inlier.

The number of points within setRadiusSearch() from the query point will need to be equal or greater than this number in order to be classified as an inlier point (i.e. will not be filtered).

Parameters

  min_pts | The minimum number of neighbors (default = 1).

Definition at line 126 of file radius_outlier_removal.h.

## setRadiusSearch()

template<typename PointT>

void pcl::RadiusOutlierRemoval< PointT >::setRadiusSearch | ( | double | radius | ) |

inline

Set the radius of the sphere that will determine which points are neighbors.

The number of points within this distance from the query point will need to be equal or greater than setMinNeighborsInRadius() in order to be classified as an inlier point (i.e. will not be filtered).

Parameters

  [in] | radius | The radius of the sphere for nearest neighbor searching.

Definition at line 104 of file radius_outlier_removal.h.

The documentation for this class was generated from the following files:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/filters/include/pcl/filters/radius_outlier_removal.h
- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/filters/include/pcl/filters/impl/radius_outlier_removal.hpp